'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LinkModel = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _BaseModel2 = require('./BaseModel');

var _PointModel = require('./PointModel');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// src


var LinkModel = exports.LinkModel = function (_BaseModel) {
  _inherits(LinkModel, _BaseModel);

  function LinkModel() {
    var linkType = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'default';

    _classCallCheck(this, LinkModel);

    var _this = _possibleConstructorReturn(this, (LinkModel.__proto__ || Object.getPrototypeOf(LinkModel)).call(this));

    _this.linkType = linkType;
    _this.points = _this.getDefaultPoints();
    _this.extras = {};
    _this.sourcePort = null;
    _this.targetPort = null;
    return _this;
  }

  // $FlowFixMe


  _createClass(LinkModel, [{
    key: 'deSerialize',
    value: function deSerialize(ob) {
      var _this2 = this;

      _get(LinkModel.prototype.__proto__ || Object.getPrototypeOf(LinkModel.prototype), 'deSerialize', this).call(this, ob);
      this.linkType = ob.type;
      this.points = ob.points.map(function (point) {
        var p = new _PointModel.PointModel(_this2, { x: point.x, y: point.y });
        p.deSerialize(point);
        return p;
      });
    }
  }, {
    key: 'serialize',
    value: function serialize() {
      // $FlowFixMe
      return _extends({}, _get(LinkModel.prototype.__proto__ || Object.getPrototypeOf(LinkModel.prototype), 'serialize', this).call(this), {
        type: this.linkType,
        // $FlowFixMe
        source: this.sourcePort ? this.sourcePort.getParent().id : null,
        sourcePort: this.sourcePort ? this.sourcePort.id : null,
        target: this.targetPort ? this.targetPort.getParent().id : null,
        targetPort: this.targetPort ? this.targetPort.id : null,
        points: this.points.map(function (point) {
          return point.serialize();
        }),
        extras: this.extras
      });
    }
  }, {
    key: 'remove',
    value: function remove() {
      _get(LinkModel.prototype.__proto__ || Object.getPrototypeOf(LinkModel.prototype), 'remove', this).call(this);
      if (this.sourcePort) {
        this.sourcePort.removeLink(this);
      }
      if (this.targetPort) {
        this.targetPort.removeLink(this);
      }
    }
  }, {
    key: 'isLastPoint',
    value: function isLastPoint(point) {
      return this.getPointIndex(point) === this.points.length - 1;
    }
  }, {
    key: 'getDefaultPoints',
    value: function getDefaultPoints() {
      return [new _PointModel.PointModel(this, { x: 0, y: 0 }), new _PointModel.PointModel(this, { x: 0, y: 0 })];
    }
  }, {
    key: 'getPointIndex',
    value: function getPointIndex(point) {
      return this.points.indexOf(point);
    }
  }, {
    key: 'getPointModel',
    value: function getPointModel(id) {
      for (var i = 0; i < this.points.length; i++) {
        if (this.points[i].id === id) {
          return this.points[i];
        }
      }
      return null;
    }
  }, {
    key: 'getFirstPoint',
    value: function getFirstPoint() {
      return this.points[0];
    }
  }, {
    key: 'getLastPoint',
    value: function getLastPoint() {
      return this.points[this.points.length - 1];
    }
  }, {
    key: 'setSourcePort',
    value: function setSourcePort(port) {
      port.addLink(this);
      this.sourcePort = port;
    }
  }, {
    key: 'getSourcePort',
    value: function getSourcePort() {
      return this.sourcePort;
    }
  }, {
    key: 'getTargetPort',
    value: function getTargetPort() {
      return this.targetPort;
    }
  }, {
    key: 'setTargetPort',
    value: function setTargetPort(port) {
      port.addLink(this);
      this.targetPort = port;
    }
  }, {
    key: 'getPoints',
    value: function getPoints() {
      return this.points;
    }
  }, {
    key: 'setPoints',
    value: function setPoints(points) {
      this.points = points;
    }
  }, {
    key: 'removePoint',
    value: function removePoint(pointModel) {
      this.points.splice(this.getPointIndex(pointModel), 1);
    }
  }, {
    key: 'addPoint',
    value: function addPoint(pointModel) {
      var index = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

      this.points.splice(index, 0, pointModel);
    }
  }, {
    key: 'getType',
    value: function getType() {
      return this.linkType;
    }
  }]);

  return LinkModel;
}(_BaseModel2.BaseModel);