'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NodeModel = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _BaseModel2 = require('./BaseModel');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// libs


// src


var NodeModel = exports.NodeModel = function (_BaseModel) {
  _inherits(NodeModel, _BaseModel);

  function NodeModel() {
    var nodeType = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'default';

    _classCallCheck(this, NodeModel);

    var _this = _possibleConstructorReturn(this, (NodeModel.__proto__ || Object.getPrototypeOf(NodeModel)).call(this));

    _this.nodeType = nodeType;
    _this.x = 0;
    _this.y = 0;
    _this.extras = {};
    _this.ports = {};
    return _this;
  }

  _createClass(NodeModel, [{
    key: 'deSerialize',
    value: function deSerialize(ob) {
      _get(NodeModel.prototype.__proto__ || Object.getPrototypeOf(NodeModel.prototype), 'deSerialize', this).call(this, ob);
      this.nodeType = ob.type;
      this.x = ob.x;
      this.y = ob.y;
      this.extras = ob.extras;
    }
  }, {
    key: 'serialize',
    value: function serialize() {
      // $FlowFixMe
      return _extends({}, _get(NodeModel.prototype.__proto__ || Object.getPrototypeOf(NodeModel.prototype), 'serialize', this).call(this), {
        type: this.nodeType,
        x: this.x,
        y: this.y,
        extras: this.extras,
        ports: _lodash2.default.map(this.ports, function (port) {
          return port.serialize();
        })
      });
    }
  }, {
    key: 'remove',
    value: function remove() {
      _get(NodeModel.prototype.__proto__ || Object.getPrototypeOf(NodeModel.prototype), 'remove', this).call(this);
      for (var key in this.ports) {
        _lodash2.default.forEach(this.ports[key].getLinks(), function (link) {
          return link.remove();
        });
      }
    }
  }, {
    key: 'getPortFromID',
    value: function getPortFromID(id) {
      for (var key in this.ports) {
        if (this.ports[key].id === id) {
          return this.ports[key];
        }
      }
      return null;
    }
  }, {
    key: 'getPort',
    value: function getPort(name) {
      return this.ports[name];
    }
  }, {
    key: 'getPorts',
    value: function getPorts() {
      return this.ports;
    }
  }, {
    key: 'removePort',
    value: function removePort(port) {
      // Clear the parent node reference
      if (this.ports[port.name]) {
        this.ports[port.name].setParentNode(null);
        delete this.ports[port.name];
      }
    }
  }, {
    key: 'addPort',
    value: function addPort(port) {
      port.setParentNode(this);
      this.ports[port.name] = port;
      return port;
    }
  }, {
    key: 'getType',
    value: function getType() {
      return this.nodeType;
    }
  }]);

  return NodeModel;
}(_BaseModel2.BaseModel);